#include <qtimer.h>

QTimer timer;

void frmSettings::init()
{
	connect(&timer, SIGNAL(timeout()), SLOT(onTimer()));
	timer.start(0, true);	
}

void frmSettings::onService()
{
	if (txtService->text().isEmpty())
		txtService->setText("/sbin/service");

	txtService->setEnabled(1);
	txtIptablesSave->setEnabled(0);
	
	txtIptablesSave->setText("");

	rdoIptablesSave->setChecked(0);
}

void frmSettings::onIptablesSave()
{
	if (txtIptablesSave->text().isEmpty())
		txtIptablesSave->setText("/usr/local/sbin/iptables-save");

	txtService->setEnabled(0);
	txtIptablesSave->setEnabled(1);

	txtService->setText("");

	rdoService->setChecked(0);
}

void frmSettings::onEnableSave( bool value )
{
	rdoService->setEnabled(value);
	rdoIptablesSave->setEnabled(value);
	txtService->setEnabled(value);
	txtIptablesSave->setEnabled(value);

	if (value)
		onService();
}

void frmSettings::onSave()
{
	onEnableSave(chkSave->isChecked());

	if (!chkSave->isChecked())
	{
		txtService->setText("");
		txtIptablesSave->setText("");
	}
	else
	{
		rdoService->setChecked(1);
		onService();
	}
}

void frmSettings::onTimer()
{
	onEnableSave(0);

	if (!txtService->text().isEmpty())
	{
		chkSave->setChecked(1);
		onSave();
		rdoService->setChecked(1);
		onService();
	}
	else
	{
		if (!txtIptablesSave->text().isEmpty())
		{
			chkSave->setChecked(1);
			onSave();
			rdoIptablesSave->setChecked(1);
			onIptablesSave();
		}
	}	
}
