#include <variables.h>
#include <frmabout.h>
#include <frmsettings.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qtextstream.h>
#include <qmessagebox.h>

void frmMain::init()
{
    setMod(false);
    
    currentFile = "";
    currentPath = QDir::homeDirPath();
    
    QDir dir(QDir::homeDirPath() + "/.ipt-qt-conf");
	
     if (!dir.exists())
	QDir().mkdir(dir.path());
    
    QFile fin(dir.path() + "/userdefchains");
    
    if (fin.exists())
    {
	fin.open(IO_ReadOnly);
    
	QTextStream stream(&fin);
    
	while (!stream.atEnd())
	    cmbUserDefined->insertItem(stream.readLine(), cmbUserDefined->count());
    
	fin.close();
	
	cmbUserDefined->clearEdit();
    }    
}

void frmMain::OnAddRule()
{
    CheckSettings(false);
     
    QString neg = "";
    
    QString userdefined = "";
    
    bool prevChecked = false;
    
    QMessageBox msg0("Error", 
		    "Target RETURN cannot be used together with built-in chain!",
		    QMessageBox::Critical,
		    QMessageBox::Ok,
		    QMessageBox::NoButton,
		    QMessageBox::NoButton);
    
    QMessageBox msg1("Confirm", 
		    "Chain equals target!\nYou really want to add that rule?",
		    QMessageBox::Warning,
		    QMessageBox::Yes,
		    QMessageBox::No,
		    QMessageBox::NoButton);
    
    QMessageBox msg2("Error", 
		    "You must specify both input and output interface for chain FORWARD!",
		    QMessageBox::Critical,
		    QMessageBox::Ok,
		    QMessageBox::NoButton,
		    QMessageBox::NoButton);
    
    QMessageBox msg3("Error", 
		    "Input and output interfaces are the same!",
		    QMessageBox::Critical,
		    QMessageBox::Ok,
		    QMessageBox::NoButton,
		    QMessageBox::NoButton);
    
    QMessageBox msg4("Confirm", 
		    "Rule already exists!\nDo You want to add it nevertheless?",
		    QMessageBox::Warning,
		    QMessageBox::Yes,
		    QMessageBox::No,
		    QMessageBox::NoButton);
    
    int permission = QMessageBox::Yes;
    
    QString rule(iptPath + " -A ");
    
    if (rdoInput->isChecked())
	rule += "INPUT";
    else
    {
	if (rdoOutput->isChecked())
	    rule += "OUTPUT";
	else
	{
	    if (rdoForward->isChecked())
		rule += "FORWARD";
	    else
	    	rule += cmbUserDefined->currentText();
	}
    }
    
    if (chkInInNeg->isChecked())
	neg = "! ";
    
    if ( (!cmbInInName->currentText().isEmpty()) && 
	 (rdoForward->isChecked() || rdoInput->isChecked() || 
	  rdoUserDefined->isChecked()) )
    {
	rule += (" -i " + neg + cmbInInName->currentText());
	
	      if (!cmbInInNumber->currentText().isEmpty())
		  rule += cmbInInNumber->currentText();
    }
    
    neg = "";
    
    if (chkInOutNeg->isChecked())
	neg = "! ";
    
    if ( (!cmbInOutName->currentText().isEmpty()) && 
	 (rdoForward->isChecked() || rdoOutput->isChecked() ||
	  rdoUserDefined->isChecked()) )
    {
	rule += (" -o " + neg + cmbInOutName->currentText());
	
	      if (!cmbInOutNumber->currentText().isEmpty())
		  rule += cmbInOutNumber->currentText();
    }
    
    neg = "";
    
    if (chkProtocolNeg->isChecked())
	neg = "! ";
    
    if (!cmbProtocol->currentText().isEmpty())
	rule += (" -p " + neg + cmbProtocol->currentText());
    
    if (!cmbProtocol->currentText().isEmpty())
    {
	if (cmbProtocol->currentText() == "tcp")
	{
	    if (chkNeg->isChecked())
		neg = "! ";
		
	    if (chkSyn->isChecked())
	    {
		rule += (" --tcp-flags " + neg + "ALL SYN");
		prevChecked = true;
	    }
	    
	    if (chkAck->isChecked())
	    {
		if (prevChecked == false)
		    rule += (" --tcp-flags " + neg + "ALL ACK");
		else
		    rule += ",ACK";
	
		prevChecked = true;
	    }
	    
	    if (chkFin->isChecked())
	    {
		if (prevChecked == false)
		    rule += (" --tcp-flags " + neg + "ALL FIN");
		else
		    rule += ",FIN";
	
		prevChecked = true;
	    }
	    
	    if (chkRst->isChecked())
	    {
		if (prevChecked == false)
		    rule += (" --tcp-flags " + neg + "ALL RST");
		else
		    rule += ",RST";
	
		prevChecked = true;
	    }
	    
	    if (chkPsh->isChecked())
	    {
		if (prevChecked == false)
		    rule += (" --tcp-flags " + neg + "ALL PSH");
		else
		    rule += ",PSH";
	
		prevChecked = true;
	    }
	    
	    if (chkUrg->isChecked())
	    {
		if (prevChecked == false)
		    rule += (" --tcp-flags " + neg + "ALL URG");
		else
		    rule += ",URG";
	
		prevChecked = true;
	    }
	    
	    if (chkAll->isChecked())
	    {
		if (prevChecked == false)
		    rule += (" --tcp-flags " + neg + "ALL ALL");
		else
		    rule += ",ALL";
	
		prevChecked = true;
	    }
	    
	    if (chkNone->isChecked())
	    {
		if (prevChecked == false)
		    rule += (" --tcp-flags " + neg + "ALL NONE");
		else
		    rule += ",NONE";
	
		prevChecked = true;
	    }
	}
	
	prevChecked = false;
	
	neg = "";
	
	if (chkSrcPortsNeg->isChecked())
	    neg = "! ";
	
	if (!txtSrcPorts->text().isEmpty())
	    rule += (" --sport " + neg + txtSrcPorts->text());
	
	neg = "";
	
	if (chkDstPortsNeg->isChecked())
	    neg = "! ";
	
	if (!txtDstPorts->text().isEmpty())
	    rule += (" --dport " + neg + txtDstPorts->text());
    }
    
    if (chkSrcIpsNeg->isChecked())
	neg = "! ";
    
    if (!txtSrcIps->text().isEmpty())
	rule += (" -s " + neg + txtSrcIps->text());

    neg = "";
    
    if (chkDstIpsNeg->isChecked())
	neg = "! ";
    
    if (!txtDstIps->text().isEmpty())
	rule += (" -d " + neg + txtDstIps->text());
    
    if (chkNew->isChecked())
    {
	rule += " -m state --state NEW";
	prevChecked = true;
    }
    
    if (chkEstablished->isChecked())
    {
	if (prevChecked == false)
	    rule += " -m state --state ESTABLISHED";
	else
	    rule += ",ESTABLISHED";
	
	prevChecked = true;
    }
    
    if (chkRelated->isChecked())
    {
	if (prevChecked == false)
	    rule += " -m state --state RELATED";
	else
	    rule += ",RELATED";
	
	prevChecked = true;
    }
    
    if (chkInvalid->isChecked())
    {
	if (prevChecked == false)
	    rule += " -m state --state INVALID";
	else
	    rule += ",INVALID";
	
	prevChecked = true;
    }
    
    if (!txtLimit->text().isEmpty())
	rule += (" -m limit --limit " + txtLimit->text());
    
    if (!txtLimitBurst->text().isEmpty())
    {
	if (txtLimit->text().isEmpty())
	    rule += (" -m limit --limit-burst " + txtLimitBurst->text());
	else
	    rule += (" --limit-burst " + txtLimitBurst->text());
    }
    
    rule += (" -j " + cmbTarget->currentText());
    
    if (cmbTarget->currentText() == "LOG")
	rule += (" --log-prefix '" + txtPrefix->text() + "'");
    
    if (!rdoUserDefined->isChecked() && cmbTarget->currentItem() == 4)
    {
	permission = QMessageBox::No;
	msg0.exec();
    }
    
    if (
	    ( rdoUserDefined->isChecked() ) && 
	    ( cmbUserDefined->currentText() == cmbTarget->currentText() ) &&
	    ( permission == QMessageBox::Yes )
       )
	permission = msg1.exec();
    
    if ( 
	    (permission == QMessageBox::Yes) && (rdoForward->isChecked()) && 
	 ( (cmbInInName->currentItem() != 0 && cmbInOutName->currentItem() == 0) ||
	   (cmbInInName->currentItem() == 0 && cmbInOutName->currentItem() != 0) )
       )
    {
	permission = QMessageBox::No;
	msg2.exec();
    }
    
    if (
	    (permission == QMessageBox::Yes) && 
	    (cmbInInName->currentItem() != 0) &&
	    (cmbInInName->currentItem() == cmbInOutName->currentItem()) &&
	    (cmbInInNumber->currentItem() == cmbInOutNumber->currentItem())
       )
    {
	permission = QMessageBox::No;
	msg3.exec();
    }
    
    if (permission == QMessageBox::Yes)
    {
	if (isOnTheList(rule))
	    permission = msg4.exec();
    }
        
    if (permission == QMessageBox::Yes)
    {
	userdefined = (iptPath + " -N " + cmbUserDefined->currentText());
	
	if (!isOnTheList(userdefined) && rdoUserDefined->isChecked())
	    lstRules->insertItem(userdefined, lstRules->count());
	
	userdefined = (iptPath + " -N " + cmbTarget->currentText());
	
	if (!isOnTheList(userdefined) && (cmbTarget->currentItem() > 4))
	    lstRules->insertItem(userdefined, lstRules->count());	    
	
	lstRules->insertItem(rule, lstRules->count());
	lstRules->setSelected(lstRules->count() - 1, 1);
	lstRules->ensureCurrentVisible();
	
	setMod(true);
	
	LockUnlockRulesButtons();
    }        
}

void frmMain::OnDeleteRule()
{
    QMessageBox msg("Confirm", 
		    "You want to delete rule:\n" 
		    + lstRules->text(lstRules->currentItem())
		    + "\nAre You sure?",
		    QMessageBox::Warning,
		    QMessageBox::Yes,
		    QMessageBox::No,
		    QMessageBox::NoButton);
		    
    if (lstRules->isSelected(lstRules->currentItem()))
    {
	if (msg.exec() == QMessageBox::Yes)
	{
	    lstRules->removeItem(lstRules->currentItem());
	    lstRules->setSelected(lstRules->currentItem(), 1);
    
	    txtSelectedRule->clear();
    
	    txtSelectedRule->setText(lstRules->text(lstRules->currentItem()));
	
	    setMod(true);
	    
	    LockUnlockRulesButtons();	   
	}
    }
}

void frmMain::OnInput()
{
    cmbUserDefined->clearEdit();
    cmbUserDefined->setEnabled(0);
    
    chkInOutNeg->setEnabled(0);
    cmbInOutName->setEnabled(0);
    cmbInOutNumber->setEnabled(0);
    
    chkInInNeg->setEnabled(1);
    cmbInInName->setEnabled(1);
}


void frmMain::OnOutput()
{
    cmbUserDefined->clearEdit();
    cmbUserDefined->setEnabled(0);
        
    chkInOutNeg->setEnabled(1);
    cmbInOutName->setEnabled(1);
        
    chkInInNeg->setEnabled(0);
    cmbInInName->setEnabled(0);
    cmbInInNumber->setEnabled(0);
}

void frmMain::OnForward()
{
    cmbUserDefined->clearEdit();
    cmbUserDefined->setEnabled(0);
    
    chkInOutNeg->setEnabled(1);
    cmbInOutName->setEnabled(1);
        
    chkInInNeg->setEnabled(1);
    cmbInInName->setEnabled(1);   
}

void frmMain::OnProtocol()
{   
    chkSyn->setEnabled(0);
    chkAck->setEnabled(0);
    chkFin->setEnabled(0);
    chkRst->setEnabled(0);
    chkPsh->setEnabled(0);
    chkUrg->setEnabled(0);
    chkAll->setEnabled(0);
    chkNone->setEnabled(0);
    chkNeg->setEnabled(0);
    
    chkSrcPortsNeg->setChecked(0);
    chkDstPortsNeg->setChecked(0);
    
    chkSrcPortsNeg->setEnabled(0);
    chkDstPortsNeg->setEnabled(0);
    
    txtSrcPorts->setEnabled(0);
    txtDstPorts->setEnabled(0);	
    
    if (!cmbProtocol->currentText().isEmpty())
	chkProtocolNeg->setEnabled(1);
    else
	chkProtocolNeg->setEnabled(0);	    
    
    if (cmbProtocol->currentText() == "tcp")
    {
	chkSyn->setEnabled(1);
	chkAck->setEnabled(1);
	chkFin->setEnabled(1);
	chkRst->setEnabled(1);
	chkPsh->setEnabled(1);
	chkUrg->setEnabled(1);
	chkAll->setEnabled(1);
	chkNone->setEnabled(1);
	chkNeg->setEnabled(1);
	
	chkSrcPortsNeg->setEnabled(1);
	chkDstPortsNeg->setEnabled(1);
	
	txtSrcPorts->setEnabled(1);
	txtDstPorts->setEnabled(1);
    }
    else
    {
	if (cmbProtocol->currentText() == "udp")
	{
	    chkSrcPortsNeg->setEnabled(1);
	    chkDstPortsNeg->setEnabled(1);
	    
	    txtSrcPorts->setEnabled(1);
	    txtDstPorts->setEnabled(1);
	}	
    }
}

void frmMain::OnUp()
{
    QString tmp0, tmp1;
    unsigned int current = lstRules->currentItem();
    
    if (current > 0)
    {
	tmp0 = lstRules->text(current - 1);
	tmp1 = lstRules->text(current);    
    
	lstRules->changeItem(tmp0, current);
	lstRules->changeItem(tmp1, current - 1);
	
	setMod(true);
    }
}

void frmMain::OnDown()
{
    QString tmp0, tmp1;
    unsigned int current = lstRules->currentItem();
    
    if ((current + 1) < lstRules->count())
    {
	tmp0 = lstRules->text(current);
	tmp1 = lstRules->text(current + 1);    
    
	lstRules->changeItem(tmp1, current);
	lstRules->changeItem(tmp0, current + 1);
	
	setMod(true);
    }
    
}

void frmMain::OnClearRule()
{
    rdoInput->setChecked(1);
    
    cmbUserDefined->clearEdit();
    cmbUserDefined->setEnabled(0);
    
    chkInInNeg->setChecked(0);
    chkInOutNeg->setChecked(0);
    
    cmbInInName->setCurrentItem(0);
    cmbInInNumber->setCurrentItem(0);
    cmbInOutName->setCurrentItem(0);
    cmbInOutNumber->setCurrentItem(0);
        
    chkInOutNeg->setEnabled(0);
    cmbInOutName->setEnabled(0);
    cmbInOutNumber->setEnabled(0);
    
    chkInInNeg->setEnabled(1);
    cmbInInName->setEnabled(1);
    cmbInInNumber->setEnabled(0);
    
    chkProtocolNeg->setChecked(0);
    chkProtocolNeg->setEnabled(0);
    cmbProtocol->setCurrentItem(0);
    
    chkNew->setChecked(0);
    chkEstablished->setChecked(0);
    chkRelated->setChecked(0);
    chkInvalid->setChecked(0);
    
    chkSyn->setEnabled(0);
    chkAck->setEnabled(0);
    chkFin->setEnabled(0);
    chkRst->setEnabled(0);
    chkPsh->setEnabled(0);
    chkUrg->setEnabled(0);
    chkAll->setEnabled(0);
    chkNone->setEnabled(0);    
    chkNeg->setEnabled(0);
 
    chkSyn->setChecked(0);
    chkAck->setChecked(0);
    chkFin->setChecked(0);
    chkRst->setChecked(0);
    chkPsh->setChecked(0);
    chkUrg->setChecked(0);
    chkAll->setChecked(0);
    chkNone->setChecked(0);
    chkNeg->setChecked(0);
    
    chkSrcPortsNeg->setChecked(0);
    chkDstPortsNeg->setChecked(0);
    
    chkSrcPortsNeg->setEnabled(0);
    chkDstPortsNeg->setEnabled(0);
    
    txtSrcPorts->clear();
    txtDstPorts->clear();
    
    txtSrcPorts->setEnabled(0);
    txtDstPorts->setEnabled(0);
    
    chkSrcIpsNeg->setChecked(0);
    chkDstIpsNeg->setChecked(0);
    
    txtSrcIps->clear();
    txtDstIps->clear();
    
    cmbTarget->setCurrentItem(0);
    
    txtPrefix->clear();
    txtPrefix->setEnabled(0);
    
    txtLimit->clear();
    txtLimitBurst->clear();
    txtLimit->setEnabled(1);
    txtLimitBurst->setEnabled(1);
    
    rdoInput->setFocus();
}

void frmMain::OnTarget()
{
    if (cmbTarget->text(cmbTarget->currentItem()) == "LOG")
	txtPrefix->setEnabled(1);
    else
	txtPrefix->setEnabled(0);
    
    int count = cmbTarget->count();
        
    for (int i = 0 ; i < cmbUserDefined->count() ; i++)
    {
	for (int j = 0 ; i < count ; j++)
	{
	    if (cmbUserDefined->text(i) == cmbTarget->text(j))
	    	break;
	    else
	    {
		if (j == (count - 1))
		{
		    cmbTarget->insertItem(cmbUserDefined->text(i), count);
		    break;
		}
	    }
	}
    }
}

void frmMain::OnAddPolicy()
{
    CheckSettings(false);
    
    lstRules->insertItem( iptPath + " -P INPUT " + cmbInput->text(cmbInput->currentItem()), 0 );
    lstRules->insertItem( iptPath + " -P OUTPUT " + cmbOutput->text(cmbOutput->currentItem()), 1 );
    lstRules->insertItem( iptPath + " -P FORWARD " + cmbForward->text(cmbForward->currentItem()), 2 );
    
    lstRules->setSelected(2, 1);
    lstRules->ensureCurrentVisible();
    
    setMod(true);
    
    LockUnlockRulesButtons();
}

void frmMain::OnRules()
{
    txtSelectedRule->setText(lstRules->text(lstRules->currentItem()));
    txtSelectedRule->setFocus();    
}

void frmMain::OnPlus()
{
    lstRules->changeItem(txtSelectedRule->text(), lstRules->currentItem());
    
    setMod(true);
}

void frmMain::OnNew()
{
    CheckSettings(false);
    
    lstRules->insertItem( (iptPath + " -A "), lstRules->count());
    lstRules->setCurrentItem(lstRules->count() - 1);
    lstRules->ensureCurrentVisible();
    
    setMod(true);
    
    LockUnlockRulesButtons();    
}


void frmMain::OnStateNew()
{
    LockUnlockLimits();
}


void frmMain::OnStateEstablished()
{
    LockUnlockLimits();
}


void frmMain::OnStateRelated()
{
    LockUnlockLimits();
}


void frmMain::OnStateInvalid()
{
    LockUnlockLimits();
}


void frmMain::LockUnlockLimits()
{
    if (chkNew->isChecked() || chkEstablished->isChecked() || chkRelated->isChecked() ||
	chkInvalid->isChecked())
    {
	txtLimit->setEnabled(0);
	txtLimitBurst->setEnabled(0);
    }
    else
    {
	txtLimit->setEnabled(1);
	txtLimitBurst->setEnabled(1);
    }
}

void frmMain::LockUnlockStates()
{
    if (!txtLimit->text().isEmpty() || !txtLimitBurst->text().isEmpty())
	BoolLockUnlockStates(0);
    else
	BoolLockUnlockStates(1);
}

void frmMain::BoolLockUnlockStates( bool state )
{
    chkNew->setChecked(0);
    chkEstablished->setChecked(0);
    chkRelated->setChecked(0);
    chkInvalid->setChecked(0);
	
    chkNew->setEnabled(state);
    chkEstablished->setEnabled(state);
    chkRelated->setEnabled(state);
    chkInvalid->setEnabled(state);	
}


void frmMain::OnLimit()
{
    LockUnlockStates();
}


void frmMain::OnLimitBurst()
{
    LockUnlockStates();
}

void frmMain::OnCreateScript()
{
   QString fname = 
	   QFileDialog::getSaveFileName(currentPath, "Scripts (*.sh)", this, "", "save script");

    int slashpos;;

    if (!fname.isEmpty())
    {
	slashpos = fname.findRev("/");
	
	if (fname.right(3) != ".sh")
	    fname += ".sh";

	QFile fout(fname);
	fout.open(IO_WriteOnly);
	QTextStream stream(&fout);
	
	currentPath = fname.left(slashpos);
	currentFile = fname;

	OnSaveScript();
	
	fout.close();	
	
	frmMain::setCaption("ipt-qt-conf - [" + fname + "]");
	
	pshSaveScript->setEnabled(1);
	pshCloseScript->setEnabled(1);
	
	setMod(false);
    }
}

void frmMain::OnOpenScript()
{
   QString fname = 
	   QFileDialog::getOpenFileName(currentPath, "Scripts (*.sh)", this, "", "open script");
    
    int slashpos;
    
    if (!fname.isEmpty() && OnCloseScript())
    {
	CheckSettings(false);

	slashpos = fname.findRev("/");
	
	QFile fin(fname);
	fin.open(IO_ReadOnly);
	QTextStream stream(&fin);
    	
	unsigned int i = 0;
	QString currentLine;

	while (!stream.atEnd())
	{
		currentLine = stream.readLine();
		
		if (
			(currentLine.left(1) != "#") &&
				(currentLine != "") &&
					(currentLine.left(srvPath.length()) != srvPath || srvPath.isEmpty()) &&
						(currentLine.left(iptSavePath.length()) != iptSavePath || iptSavePath.isEmpty())
		    )
			lstRules->insertItem(currentLine, i++);
	}
 
    	fin.close();
	
	lstRules->setSelected(lstRules->count() - 1, 1);
	
	currentPath = fname.left(slashpos);
	currentFile = fname;
	
	frmMain::setCaption("ipt-qt-conf - [" + fname + "]");
	
	pshSaveScript->setEnabled(1);
	pshCloseScript->setEnabled(1);
	
	setMod(false);
	
	LockUnlockRulesButtons();
    }
}

void frmMain::OnDeleteAllRules()
{
    QMessageBox msg("Confirm", "You want to delete all rules.\nAre You sure?",
		    QMessageBox::Warning,
		    QMessageBox::Yes, QMessageBox::No, QMessageBox::NoButton);
    
    if (lstRules->count() > 0)
    {
	if (msg.exec() == QMessageBox::Yes)
	{
	    lstRules->clear();
	
	    txtSelectedRule->clear();
	
	    setMod(true);
	    
	    LockUnlockRulesButtons();
	}
    }

}

void frmMain::LockUnlockRulesButtons()
{
    pshUp->setEnabled(0);
    pshDown->setEnabled(0);
    pshDeleteRule->setEnabled(0);
    pshCopyRule->setEnabled(0);
    pshDeleteAllRules->setEnabled(0);
    pshAccept->setEnabled(0);
    txtSelectedRule->setEnabled(0);
    
    if (lstRules->count() > 0)
    {
	if (lstRules->isSelected(lstRules->currentItem()))
	{
	    pshDeleteRule->setEnabled(1);
	    pshCopyRule->setEnabled(1);
	    pshAccept->setEnabled(1);
	    txtSelectedRule->setEnabled(1);
	}
			
	if (lstRules->count() > 1)
	{
	    pshDeleteAllRules->setEnabled(1);
	    
	    if (lstRules->isSelected(lstRules->currentItem()))
	    {		
		pshUp->setEnabled(1);
		pshDown->setEnabled(1);
	    }
	}	 
    }
    
    txtSelectedRule->setFocus();
    
    lstRules->ensureCurrentVisible();
}


void frmMain::CheckSettings(bool force)
{
    CSettings settings;
    
    frmSettings frmsettings(this);
    
    settings.readValues();
    
    if (settings.getIptPath().isEmpty())
    {
	settings.setIptPath("/sbin/iptables");
	settings.setSrvPath("/sbin/service");
		
	settings.writeValues();
	
	force = true;
    }
    
    if (force)
    {	
	frmsettings.txtIptables->setText(settings.getIptPath());
	frmsettings.txtService->setText(settings.getSrvPath());
	frmsettings.txtIptablesSave->setText(settings.getIptSavePath());
	
	frmsettings.exec();
		
	settings.setIptPath(frmsettings.txtIptables->text());
	settings.setSrvPath(frmsettings.txtService->text());
	settings.setIptSavePath(frmsettings.txtIptablesSave->text());	
	
	settings.writeValues();	
    }

    iptPath = settings.getIptPath();
    srvPath = settings.getSrvPath();
    iptSavePath = settings.getIptSavePath();
}

void frmMain::OnCopyRule()
{
    unsigned int current = lstRules->currentItem();
        
    if (lstRules->isSelected(current))
    {
	lstRules->insertItem(lstRules->text(current), (current + 1));
	
	lstRules->setCurrentItem(current + 1);
	lstRules->setSelected( (current + 1), 1);
    
	lstRules->ensureCurrentVisible();
	
	setMod(true);
	
	LockUnlockRulesButtons();
    }   
}


void frmMain::OnUserDefinedRdo()
{
    chkInOutNeg->setEnabled(1);
    cmbInOutName->setEnabled(1);
        
    chkInInNeg->setEnabled(1);
    cmbInInName->setEnabled(1);
        
    lstRules->clearSelection();
    
    cmbUserDefined->setEnabled(1);
    cmbUserDefined->clearEdit();
    cmbUserDefined->setFocus();
    
}

void frmMain::OnAddFlushButton()
{
    CheckSettings(false);
    
    lstRules->insertItem(iptPath + " -F INPUT", 0 );
    lstRules->insertItem(iptPath + " -F OUTPUT", 1 );
    lstRules->insertItem(iptPath + " -F FORWARD", 2 );
    
    lstRules->setSelected(2, 1);
    lstRules->ensureCurrentVisible();
 
    setMod(true);
    
    LockUnlockRulesButtons();
}

void frmMain::OnAboutButton()
{
    frmAbout aboutfrm(this);
    aboutfrm.exec();
}

void frmMain::OnSaveScript()
{
	QFile fout(currentFile);
	QTextStream stream(&fout);
 
	fout.open(IO_WriteOnly);

	stream << "#!/bin/sh\n\n#generated by ipt-qt-conf 1.3.2\n#report bugs and wishes to amdfanatyk: amdfanatyk (at) wp (dot) pl\n\n";

	for (unsigned int i = 0 ; i < lstRules->count(); i++)
		stream << lstRules->text(i) << "\n";

	if (!srvPath.isEmpty())
		stream << "\n" << srvPath << " iptables save" << "\n";
	else
	{
		if (!iptSavePath.isEmpty())
			stream << "\n" << iptSavePath << "\n";
	}	
 
	fout.close();

	setMod(false);
}

bool frmMain::isOnTheList( QString rule )
{

    bool onTheList = false;
    
    for (unsigned int i = 0 ; i < lstRules->count() ; i++)
    {
	if (lstRules->text(i) == rule)
	{
	    onTheList = true;
	    break;
	}
    }
    
    return onTheList;
}


void frmMain::OnInInName()
{
    if (!cmbInInName->currentText().isEmpty())
	cmbInInNumber->setEnabled(1);
    else
	cmbInInNumber->setEnabled(0);
}


void frmMain::OnInOutName()
{
    if (!cmbInOutName->currentText().isEmpty())
	cmbInOutNumber->setEnabled(1);
    else
	cmbInOutNumber->setEnabled(0);
}


void frmMain::OnZero()
{
    CheckSettings(false);
    
    lstRules->insertItem(iptPath + " -Z INPUT", 0 );
    lstRules->insertItem(iptPath + " -Z OUTPUT", 1 );
    lstRules->insertItem(iptPath + " -Z FORWARD", 2 );
    
    lstRules->setSelected(2, 1);
    lstRules->ensureCurrentVisible();
 
    setMod(true);
    
    LockUnlockRulesButtons();
}

bool frmMain::OnCloseScript()
{
    QMessageBox msg("Confirm", "Do You want to save changes?",
		    QMessageBox::Warning,
		    QMessageBox::Yes,
		    QMessageBox::No,
		    QMessageBox::Cancel);
    
    int res = QMessageBox::No;
    
    if (mod)
    {
	res = msg.exec();
	
	if (res == QMessageBox::Yes)
	{
	    if (!currentFile.isEmpty())
		OnSaveScript();
	    else
		OnCreateScript();
	}
    }
    
    if (res != QMessageBox::Cancel)
    {
	currentFile = "";
    
	pshSaveScript->setEnabled(0);
	pshCloseScript->setEnabled(0);
    
	OnClearRule();
	OnDeleteAllRules();
        
	frmMain::setCaption("ipt-qt-conf");
    
	setMod(false);
	
	return true;
    }
    else
	return false;
}

void frmMain::OnSettings()
{
    CheckSettings(true);
}

void frmMain::closeEvent( QCloseEvent * e )
{
    QMessageBox msg("Confirm", "Do You want to save changes?",
		    QMessageBox::Warning,
		    QMessageBox::Yes,
		    QMessageBox::No,
		    QMessageBox::Cancel);
    
    QDir dir(QDir::homeDirPath() + "/.ipt-qt-conf");
	
    if (!dir.exists())
	QDir().mkdir(dir.path());
		    
    QFile fout(dir.path() + "/userdefchains");
    fout.open(IO_WriteOnly);
    
    QTextStream stream(&fout);    
    
    for (int i = 0 ; i < cmbUserDefined->count() ; i++)
	stream << cmbUserDefined->text(i) << "\n";
   
    fout.close();
    
    if (mod)
    {
	switch (msg.exec())
	{
	    case (QMessageBox::Yes):
		if (!currentFile.isEmpty())
		    OnSaveScript();
		else
		    OnCreateScript();
     
		e->accept();
		break;
	 
	   case (QMessageBox::No):
	             e->accept();
	             break;
		   
                 case (QMessageBox::Cancel):
	             e->ignore();
                           break;
	}
    }
    else
	e->accept();
}

void frmMain::setMod( bool isMod )
{
    mod = isMod;

    if (mod)
    {
	if (frmMain::caption().right(1) != "*")
	    frmMain::setCaption(frmMain::caption() + " *");	
    }
    else
    {
	if (frmMain::caption().right(1) == "*")
	    frmMain::setCaption(frmMain::caption().left(frmMain::caption().length() - 2));
    }
    
    if (!currentFile.isEmpty())
	pshSaveScript->setEnabled(mod);
}
