#include <variables.h>
#include <qfile.h>
#include <qdir.h>
#include <qtextstream.h>

void CSettings::setIptPath(QString path)
{
	iptPath = path;	
}

void CSettings::setSrvPath(QString path)
{
	srvPath = path;
}

void CSettings::setIptSavePath(QString path)
{
	iptSavePath = path;
}

QString CSettings::getIptPath(void)
{
	return iptPath;
}

QString CSettings::getSrvPath(void)
{
	return srvPath;
}

QString CSettings::getIptSavePath(void)
{
	return iptSavePath;
}

void CSettings::readValues(void)
{
	QDir dir(QDir::homeDirPath() + "/.ipt-qt-conf");
	
	if (!dir.exists())
		QDir().mkdir(dir.path());
		
	QFile fin(dir.path() + "/ipt-qt-conf.conf");
	fin.open(IO_ReadOnly);
	QTextStream stream(&fin);
	iptPath = stream.readLine();
	srvPath = stream.readLine();
	iptSavePath = stream.readLine();
	fin.close();	
}

void CSettings::writeValues(void)
{
	QDir dir(QDir::homeDirPath() + "/.ipt-qt-conf");
	
	if (!dir.exists())
		QDir().mkdir(dir.path());

	QFile fout(dir.path() + "/ipt-qt-conf.conf");
	fout.open(IO_WriteOnly);
	QTextStream stream(&fout);
	stream << iptPath << "\n" << srvPath << "\n" << iptSavePath << "\n";
	fout.close();
}
